/*
 * Wcommon.c
 *              Motif/Lesstif standard I/O library widget common routine 
 *		Version 1.00
 *
 * Programmer: Park Jae-Ho(jrogue@netian.com), Lee Hai-Young
 *
 * This project is inspired by the WINIO library in UNDOCUMENTED WINDOWS.
 * This library can be copied, modified, used by others,
 * BUT PLEASE PROVIDE THAT ABOVE NOTICE APPEAR IN ALL COPIES OF THIS LIBRARY.
 */

#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/RowColumn.h>
#include <Xm/Separator.h>
#include <assert.h>
#include "Wcommon.h"

Widget topLevel;
Display* display;
XtAppContext app;
static int bisInit = FALSE;

void WcommonInit ( int argc, char **argv )
{
	if ( bisInit ) return;
	bisInit = TRUE;

	topLevel = XtVaAppInitialize( &app, "Generic", NULL, 0, &argc, argv,
				NULL, NULL );

	display = XtDisplay( topLevel );

	XtVaSetValues( topLevel,
			XmNmappedWhenManaged, FALSE,
			XmNx, DisplayWidth( display, 0 ) /2,
			XmNy, DisplayHeight( display, 0 ) /2,
			XmNwidth,  1,
			XmNheight, 1,
			NULL );

	XtRealizeWidget( topLevel );
}

void Wcontrol ( void )
{
	XEvent event;

	while ( XtAppPending( app ) ) {
		XtAppNextEvent( app, &event );
		XtDispatchEvent ( &event );
	}
}

char Wgetch ( Widget target )
{
	XWMHints wmhint;
	XEvent event;
	KeySym key;
	int b = True;
	char szT[20];

	wmhint.input = True;
	wmhint.flags |= InputHint;
	XSetWMHints( XtDisplay( target ), XtWindow( target ), &wmhint );
	XSelectInput( XtDisplay( target ), XtWindow( target ), KeyPressMask );

	XFlush( display );
	while ( b ) {
		XtAppNextEvent( app, &event );
		if ( event.type == KeyPress &&
			event.xany.window == XtWindow( target ) )
				b = False;
		else
			XtDispatchEvent ( &event );
	}
	XLookupString( &event, szT, 20, &key, NULL );

	wmhint.input = False;
	wmhint.flags ^= InputHint;
	XSetWMHints( XtDisplay( target ), XtWindow( target ), &wmhint );

	return szT[0];
}
