/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

// : gcc 2.9x迭 complex.h Ŭϸ ANSI C++ complex Ŭ
// Ϸ ϹǷ   ߻Ѵ.
//#include <complex.h>
//  ӽ  complex double  Ҵ.
typedef double complex;

// math.h ־ exp Լ θ ã  ִ. ̸    ߻Ѵ.
#include <math.h>

#include <iostream.h>

//  ޸ time  mytime Ѵ.
typedef double mytime;

class SeriesRLCStepResponse {
public:
    complex (SeriesRLCStepResponse::*current)(mytime t);
    SeriesRLCStepResponse(double r, double l,
        double c, double initialCurrent);
    double frequency() const { return 1.0 / sqrt(L * C); }
private:
    complex underDampedResponse(mytime t) {
        return exp(-alpha * t) * (b1 * cos(omegad * t) +
               b2 * sin(omegad * t));
    }
    complex overDampedResponse(mytime t) {
        return a1 * exp(s1 * t) + a2 * exp(s2 * t);
    }
    complex criticallyDampedResponse(mytime t) {
        return exp(-alpha * t) * (a1 * t + a2);
    }
    double R, L, C, currentT0, alpha;
    complex omegad, a1, b1, a2, b2, s1, s2;
};

SeriesRLCStepResponse::SeriesRLCStepResponse(
        double r, double l, double c, double initialCurrent) {
    R = r; L = l; C = c; currentT0 = initialCurrent;
    alpha = R / (L + L);
    omegad = sqrt(frequency() * frequency() - alpha * alpha);

    // ...

    if (alpha < frequency()) {
        current = &SeriesRLCStepResponse::underDampedResponse;
    } else if (alpha > frequency()) {
        current = &SeriesRLCStepResponse::overDampedResponse;
    } else {
        current = &SeriesRLCStepResponse::criticallyDampedResponse;
    }
}

int main()
{
    double R, L, C, I0;
    cin >> R >> L >> C >> I0;
    SeriesRLCStepResponse aFilter(R, L, C, I0);
    for (mytime t = 1.0; t < 100; t += 1.0) {
        cout << (aFilter.*(aFilter.current))(t) << endl;
    }
    return 0;
}
