/* Advanced C++ Programming Styles and Idioms */


class StringRep {
friend class String;
private:
    StringRep(const char *s) {
       ::strcpy(rep = new char[::strlen(s)+1], s);
       count = 1;
    }
    ~StringRep() { delete[] rep; }
private:
    char *rep;
    int count;
};

class String {
public:
    String()                 { rep = new StringRep(""); }
    String(const String &s)  { rep = s.rep; rep->count++; }
    String(const char *s)    { rep = new StringRep(s); }
    ~String()                { if (--rep->count <= 0) delete rep; }
    String &operator=(const String &s) {
        s.rep->count++;
        if (--rep->count <= 0) delete rep;
        rep = s.rep;
        return *this;
    }
    String operator+(const String&) const;   // ٸ  
    operator const char * () const  { return rep->rep; }
    String operator() (int, int) const;
    //  Ʈ, 3  
    int length() const    { return ::strlen(rep->rep); }

protected:
    StringRep *rep;
};

class PathName: public String {
public:
    PathName(const String&);
    PathName(): baseNameRep(""), String() { }
    PathName(const PathName &p): String(p), baseNameRep(p.baseNameRep) {
    /* ִ */ }
    PathName &operator=(const PathName &p) {
        String::operator=(p);
        baseNameRep = p.baseNameRep;
        return *this;
    }
    ~PathName() { /* ִ */ }
    String baseName() { return baseNameRep; }
    String prefix();
    String suffix();
    String fullPathName() { return *this; }
    String dirName() {
        return (*this)(0, length() - baseName().length());
    }
    String changeBaseName(const String &newFile);
private:
    String baseNameRep;
};
