/* Copyright (c) 1992 by AT&T Bell Laboratories. */
/* Advanced C++ Programming Styles and Idioms */
/* James O. Coplien */
/* All rights reserved. */

// String Ŭ (STL ȰѴ)
#include <string>
// for isxyz function
#include <ctype.h>

class Exemplar { public: Exemplar() { } };

class Atom {
protected:
    static Atom *list;
    Atom *next;
    static char errFlag;
public:   //  Atom  
    Atom(Exemplar) { next = list; list = this; }
    virtual Atom *make(string &s) {
        Atom *retval = 0;
        extern Atom *atomExemplar;
        for (Atom *a = list; a; a = a->next) {
            if (a != atomExemplar) {
                if (retval = a->make(s)) break;
            }
        }
        return retval;
    }
    Atom() { next = 0; errFlag = 0; }
    virtual ~Atom() { }
    virtual unsigned long value() { return 0; }
    virtual string name() { return string("error"); }
    virtual operator char() { return 0; }
};
Atom *Atom::list = 0;
//  static 
Atom atomInstance(Exemplar());
//  Ÿ ȯ  (Atom*) ߰
Atom *atomExemplar = (Atom*)&atomInstance;

class Number: public Atom {
    Number(Exemplar a): Atom(a) { }
    Number(string &s): Atom() {
        sum = 0;
        int i;
        for (i = 0; s[i] >= '0' && s[i] <= '9'; i++) {
            sum = (sum * 10) + s[i] - '0';
        }
        char c = s[i]; errFlag = !(ispunct(c) || isspace(c));
    }
    Number(Number &n) { sum = n.value(); }
    Atom *make(string &s) {
        Atom *retval = new Number(s);
        if (errFlag) { delete retval; retval = 0; }
        return retval;
    }
    ~Number() { }
    unsigned long value() const { return sum; }
private:
    unsigned long sum;
};
//  static 
Number numberInstance(Exemplar());

class Name: public Atom {
public:
    Name(Exemplar a): Atom(a) { }
    Name(string &s): Atom() {
        int i;
        for (i = 0; s[i] >= 'a' && s[i] <= 'z'; i++)
              n += s.substr(i, i + 1);
        // STL string ϱ  
        //    n += s(i, 1);
        //  ̸ ƴϸ errFlag  caller ȣѴ.
        if (!isalnum(s[i])) errFlag++;
    }
    Atom *make(string &s) {
        Atom *retval = new Name(s);
        if (errFlag) { delete retval; retval = 0; }
        return retval;
    }
    Name(Name &m) { n = m.name(); }
    ~Name() { }
    string name() { return n; }
private:
    string n;
};
static Name nameInstance(Exemplar());

class Punct: public Atom {
public:
    Punct(Exemplar a): Atom(a) { }
    Punct(string &s): Atom() {
        if (!ispunct(s[0])) errFlag++;
        s = s.substr(1, s.length() - 1);
        // STL string ϱ  
        // s = s(1, s.length() - 1);
    }
    Atom *make(string &s) {
        Atom *retval = new Punct(s);
        if (!errFlag) { delete retval; retval = 0; }
        return retval;
    }
    Punct(Punct &p) { c = char(p); }
    operator char() { return c; }
    ~Punct() { }
private:
    char c;
};
static Punct punctInstance(Exemplar());

class Oper: public Atom {
//. . . .
};
