/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 2-8 */

// stack implementation with no size limitation

#include <iostream.h>

class Stack {
public:
    Stack();
    ~Stack();
    long top() const;
    long pop();
    void push(long);
    bool empty();

private:
    struct Node {
        long  value;
        Node* next;
    };
    Node *items;
};

Stack::Stack() {
    items = 0;
}

Stack::~Stack() {
    while (items != 0) pop();
}

long Stack::top() const {
    return items->value;
}

long Stack::pop() {
    Node* top    = items;
    long  retval = top->value;
	
    items = items->next;
    delete top;

    return retval;
}

void Stack::push(long i) {
    Node* top  = new Node;
    top->value = i;
    top->next  = items;
    items      = top;
}

bool Stack::empty() {
    return (items == 0);
}

int main()
{
    Stack q;        

    q.push(23);
    cout << "push " << q.top() << endl;

    q.push(11);
    cout << "push " << q.top() << endl;

    cout << "pop " << q.pop() << endl;
    cout << "pop " << q.pop() << endl;

    if (q.empty())
        cout << "stack is empty." << endl;
    else
        cout << "stack is not empty." << endl;

    return 0;
}
