/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 3-7 */

#include <iostream.h>
#include <stddef.h>

#define POOLSIZE            128
static unsigned char        memPool[POOLSIZE];
static const unsigned char* memPoolEnd = memPool + POOLSIZE * sizeof(char);

struct Head {
    long    length;
    struct  Head* next;
};

static Head  pool = { 0, 0 };
static Head* h = (Head *)memPool;

typedef char* Char_p;

const long WRDSIZE = sizeof(void*);

void* operator new(size_t nbytes) 
{
    if (pool.next) {
        Head* prev = &pool;
        for (Head* cur = &pool; cur; cur = cur->next) {
            if (cur->length >= (long)nbytes) {
                prev->next = cur->next;
                return (void*)(Char_p(cur) + sizeof(Head));
            }
            else
                prev = cur;
        }
    }    

    // check if we have enough memory to allocate
    size_t memLeft     = (size_t)(Char_p(memPoolEnd) - Char_p(h));
    size_t memRequired = nbytes + sizeof(Head);
    if (memRequired > memLeft) {
        cout << "out of memory." << endl;
        throw;
    }

    h = (Head*)(((int)((Char_p(h)+WRDSIZE-1))/WRDSIZE)*WRDSIZE);
    h->next   = 0;
    h->length = nbytes;
    h = (Head *)((int)(Char_p(h) + nbytes + sizeof(Head)));
    return (void*)(Char_p(h) - nbytes);
}

void operator delete(void *ptr)
{
    Head* p = (Head*)(Char_p(ptr) - sizeof(Head));
    p->next = pool.next;
    pool.next = p;
}

int main() 
{
    int  i;
    int* pi[5];

    for (i = 0; i < 5; i++) 
        pi[i] = new int;

    for (i = 0; i < 5; i++)
        delete pi[i];

    return 0;
}
