/* Copyright (c) 2003 by Hanbit Media Co. All rights reserved*/
/* Lee, Hae-Young(hae_lee@hanmail.net) */
/* Advanced C++ Programming Styles and Idioms, exercise 6-4 */

#include <iostream>
#include <string>
#include <map>
#include <string.h>

using namespace std;

const char *COMMAND_SIZE="!size";
const char *COMMAND_PRINT="!print";

class AssociativeArray {
public:
    AssociativeArray() { }
    
    void  atPut(void* element, const char* key) {       
        if (!strcmp(key, COMMAND_SIZE)) {
            // You don't need change the map size.
            ;
        } else if (!strcmp(key, COMMAND_PRINT)) {
            cout << "<contents of the AssociativeArray>" << endl;
            map<string, void*>::iterator pos;
            for (pos = _map.begin(); pos != _map.end(); pos++) {
                cout << "key: " << pos->first << ", value: " << (int) pos->second << endl; 
            }
        } else {
            _map[string(key)] = element;
        }
    }
    void* at(const char *key) {
        if (!strcmp(key, COMMAND_SIZE)) {
            return (void*) _map.size();
        } else {
            map<string, void*>::iterator pos;
            for (pos = _map.begin(); pos != _map.end(); pos++) {
                if (!strcmp(key, (pos->first).c_str()))
                    return (void *)pos->second;
            }
            return (void *)0;
        }
    }
private:
    map<string, void*> _map;
};

int main() {
    AssociativeArray a;
    a.atPut((void *)10, "!size");
    a.atPut((void *)233, "AssociativeArray example");
    a.atPut((void *)0, "!print");
    a.atPut((void *)230, "CircularList example");
    a.atPut((void *)0, "!print");
    cout << "current size: " << (int) a.at("!size") << endl;

    int circlistPage = (int)a.at("CircularList example");
    cout << "should be 230 = " << circlistPage << endl;

    return 0;
}
